<%@ page language="java" contentType="text/html;charset=UTF-8" pageEncoding="UTF-8" %>
<%@ page import="com.micromuse.sla.configclient.*" %>
<%@ page import="com.micromuse.sla.soap.*" %>
<%@ page import="com.micromuse.sla.beans.*" %>
<%@ page import="com.micromuse.common.util.Debug" %>
<%@ page import="com.micromuse.sla.soap.RADFacadeIfc" %>

<%@ page import="com.micromuse.common.security.*" %>
<%@ page import="com.micromuse.common.security.webclient.*" %>

<head>
<script type="text/javascript" src="/desktop/js/vpmessaging.js"></script>
<script language="Javascript" src="/sla/netcool/scripts/script.js"> </script>
<script language="JavaScript" src="../scripts/prototype-1.3.1.js"></script>
<script language="JavaScript" src="../scripts/common.js"></script>

<script language="JavaScript" type="text/javascript">

  // set vpName and vpType which will be used for the actions
  var vpName = "RADStandaloneMap";
  var vpType = "RAD";
  var canvTemp = '';
  
  function getTypeIDFromParams(msg) {
    var idarray = msg.params.split(":");
    var typeID = idarray[0];
    return typeID;
  }

  function getInstanceIDFromParams(msg) {
    var idarray = msg.params.split(":");
    var instanceID = idarray[1];
    return instanceID;
  }

  function doViewCustomService(msg) {
    internalViewService(msg);
  }

  function doEditService(msg) {
    internalViewService(msg);
  }

  function doViewService(msg) {
    internalViewService(msg);
  }

  function internalViewService(msg) {
    var instanceID = getInstanceIDFromParams(msg);
    var typeID = getTypeIDFromParams(msg);
    updateServiceView(instanceID, typeID);
  }

  function doSomethingWithInstanceId(origRequest) {
    var result = trim(origRequest.responseText);
    var idarray = result.split("::");
    var inputValue = idarray[0];
    var instanceID = idarray[1];
    if (instanceID != 0) {
      var viewServiceMessage = new vpmMessage("EditService", "1:"+instanceID);
      vpmSendMessage(viewServiceMessage);
      var serviceDetailsMessage = new vpmMessage("SingleClickedOnService", instanceID+":RawEvents");
      vpmSendMessage(serviceDetailsMessage);
    } else {
      alert('Instance Does Not Exist: ' +inputValue);
    }
  }

  function loadDefaultCanvas() {
    // First check to see if ServiceInstanceID is passed in on the URL
    urlTop = location.href;
    idx1 = urlTop.indexOf("ServiceInstanceID=");
    if (idx1 != -1) {
     instanceId = urlTop.substring(idx1 + 18, urlTop.length);
        if(urlTop.indexOf("CanvasTemplate=") != -1) {
	      canvTemp = urlTop.substring(urlTop.indexOf("CanvasTemplate=") + 15,urlTop.length);
	    }	 
     updateServiceView(instanceId, "1");
     // Otherwise, check for user pref with starting id
    } else {

      <%
      // Get starting instance from User Prefs

      UserPreferencesController upc = new UserPreferencesController();
      String instanceNameIDs = upc.getUserPreference(request,
  						   "instanceNameText");
      if (instanceNameIDs != null) {
        int firstIndex = instanceNameIDs.indexOf(":");
        int secondIndex = instanceNameIDs.indexOf(":",firstIndex+1);
        String typeID = instanceNameIDs.
  	  substring(firstIndex+1, secondIndex);
        String instID = instanceNameIDs.
     	  substring(secondIndex+1,instanceNameIDs.length());
        try {
   	  SessionBeanStore sessionBeanStore = 
    	    SessionBeanStore.getInstance();		 
	  SessionTagBean sessionTagBean =
	    sessionBeanStore.getSessionTagBean(ServiceTypeBean.
   	   				       DEFAULT_TAG_NAME, request);
  	  RADFacadeIfc radFacadeIfc = 
	    sessionBeanStore.getFacadeForRequest(request);
	  //If can't find name for ID, instance does not exists anymore.
	  String name = radFacadeIfc.getInstanceName(Integer.parseInt(instID));
      %>
	  var id = '<%= instID %>';
	  var typeID = '<%= typeID %>';
	  doAction("EditService", typeID+":"+ id); 
      <%
	} catch (RADSoapException ex) {
      %> 
            alert("Starting instance set does not" +
                  " exists anymore.Someone might have" +
                  " deleted it.Please choose new starting" +
                  " instance." );
      <%
	  //Remove Starting instance preference.
          UserIfc user = (UserIfc) request.getSession().getAttribute("smUser");
	  String pref = user.getPreference("isUserPreference");
          if ( pref != null &&  pref.equals("true")) {  //user preference
	    user.deletePreference("instanceNameText");
            user.deletePreference("isUserPreference");
	  } else { // group preference
	    UserSecurityManager.deletePrimaryGroupPreference(user, "instanceNameText");
	  }
	}
      }
      %>
    }
  }

  function updateServiceView(instanceID, typeID) {
    // only do this if instanceID is not NEW
    // If not IE, have startup with full client
    var useFullClient = "";

    if (instanceID != 'NEW') {

      var showTags = false;
      if (('' + typeID == 'undefined') ||
          ('' + typeID == '')) {
        showTags = true;
      }
    
      if (showTags == true) {
        showTemplateGraphicalView(instanceID, useFullClient); // instanceID is really type id
      } else {
        showInstanceGraphicalView(typeID, instanceID, useFullClient);
      }
    }
  }

  /**
   * Shows a normal instance hierarchy view
   */
  function showInstanceGraphicalView(typeID, instanceID, useFullClient) {

    if (navigator.userAgent.indexOf("MSIE") == -1 &&
			viewService == false) {
   	  window.frames['mainview'].location = defaultLocation;	
    } else {
      // we are just showing a normal instance hierarchy view
      mainView = window.frames['mainview'];
      if (mainView.document.CanvasViewer != null) {
        mainView.document.CanvasViewer.popQueryContext();  
        mainView.document.CanvasViewer.setQueryContextVar("ServiceInstanceID", ""+instanceID);
        mainView.document.CanvasViewer.setQueryContextVar("ServiceTypeID", ""+typeID);
        mainView.document.CanvasViewer.setQueryContextVar("DispParam_UsePreferences", "true");
        mainView.document.CanvasViewer.setShowConfigToolbar(true);
        mainView.document.CanvasViewer.loadInstances();
      } else if(canvTemp !="") {
			var newLocWithCanv = "/sla/av/ServeViewerApplet?SMSessionID=DUMMY&CanvasTemplate="+canvTemp+"&ServiceTypeID=" + typeID + "&ServiceInstanceID=" + instanceID + "&DispParam_UsePreferences=true"+useFullClient;
			window.frames['mainview'].location = newLocWithCanv;
      } else {
        var newLocation = "/sla/av/ServeViewerApplet?SMSessionID=DUMMY&CanvasTemplate=Relationships&ServiceTypeID=" + typeID +"&ServiceInstanceID=" + instanceID + "&DispParam_UsePreferences=true"+useFullClient;
        window.frames['mainview'].location = newLocation;	
      }
    
      // loading URL we have to save it in case we edit the service later
	  if(canvTemp !=""){
	    appletLocation = "/sla/av/ServeViewerApplet?SMSessionID=DUMMY&CanvasTemplate="+canvTemp+"&ServiceTypeID=" + typeID +"&ServiceInstanceID=" + instanceID + "&DispParam_UsePreferences=true"+useFullClient;	
	   }
	   else {
	    appletLocation = "/sla/av/ServeViewerApplet?SMSessionID=DUMMY&CanvasTemplate=Relationships&ServiceTypeID=" + typeID +"&ServiceInstanceID=" + instanceID + "&DispParam_UsePreferences=true"+useFullClient;
       }
    }
  }
</script>
</head>

<frameset onload=loadDefaultCanvas() id="aframeset" rows="100%,0%">
  <frame border="0" framespacing="0" marginheight="0" marginwidth="0" name="mainview" id="mainview" src="/sla/av/splash.html">
  <frame border="0" framespacing="0" marginheight="0" marginwidth="0" name="hiddendispatchframe" name="hiddendispatchframe" noresize src="blank.html">
</frameset>
